--Imports
import "Turbine"
import "Turbine.UI"
import "Turbine.UI.Lotro"
import "Turbine.Gameplay"

--Initialisation
Player = Turbine.Gameplay.LocalPlayer.GetInstance();
EffectList = Turbine.Gameplay.LocalPlayer:GetInstance():GetEffects();

s = {};
d = {};
hilf = "";
loggedYet = false;

--Callback handler
function AddCallback(object, event, callback)
    if (object[event] == nil) then
        object[event] = callback;
    else
        if (type(object[event]) == "table") then
            table.insert(object[event], callback);
        else
            object[event] = {object[event], callback};
        end
    end
    return callback;
end
function RemoveCallback(object, event, callback)
    if (object[event] == callback) then
        object[event] = nil;
    else
        if (type(object[event]) == "table") then
            local size = table.getn(object[event]);
            for i = 1, size do
                if (object[event][i] == callback) then
                    table.remove(object[event], i);
                    break;
                end
            end
        end
    end
end

function delete()
	s = {};
	d = {};
end

function Logger(sender, args)
--buff
	if (Wind.buff:IsChecked()) then 
			if (EffectList:Get(args.Index):IsDebuff() == false) then
				for loggedEffects=0, table.maxn(s), 1 do
					if (EffectList:Get(args.Index):GetName() == s[loggedEffects]) then
						loggedYet = true;
					end
				end
				if (loggedYet == false) then
--					Turbine.Shell.WriteLine("false");
					table.insert(s,EffectList:Get(args.Index):GetName());
					table.insert(d,EffectList:Get(args.Index):GetDescription());
--					else Turbine.Shell.WriteLine("true");
				end
				loggedYet = false;
			end
	end
--debuff

	if (Wind.debuff:IsChecked()) then 
			if (EffectList:Get(args.Index):IsDebuff() == true and EffectList:Get(args.Index):IsCurable() == false) then
				for loggedEffects=0, table.maxn(s), 1 do
					if (EffectList:Get(args.Index):GetName() == s[loggedEffects]) then
						loggedYet = true;
					end
				end
				if (loggedYet == false) then
					table.insert(s,EffectList:Get(args.Index):GetName());
					table.insert(d,EffectList:Get(args.Index):GetDescription());
				
				end
				loggedYet = false;
			end
	end
--curable
	if (Wind.curable:IsChecked()) then 
			if (EffectList:Get(args.Index):IsCurable() == true) then
				for loggedEffects=0, table.maxn(s), 1 do
					if (EffectList:Get(args.Index):GetName() == s[loggedEffects]) then
						loggedYet = true;
					end
				end
				if (loggedYet == false) then
					table.insert(s,EffectList:Get(args.Index):GetName());
					table.insert(d,EffectList:Get(args.Index):GetDescription());
				end
				loggedYet = false;
			end
	end
end

--Window
Wind= Turbine.UI.Lotro.Window();
	Wind:Activate();
	Wind:SetSize(400,150);
	Wind:SetPosition(Turbine.UI.Display.GetWidth()/2-200,Turbine.UI.Display.GetHeight()/2-300);
	Wind:SetText("EffectLog");
	Wind:SetVisible(false);
	Wind:SetMouseVisible(true);
	Wind:SetWantsKeyEvents(true);
	
Wind.list = Turbine.UI.Lotro.Button();
	Wind.list:SetParent(Wind);
	Wind.list:SetPosition(25,75);
	Wind.list:SetSize(100,50);
	Wind.list:SetText("List Names");
	Wind.list.Click = function ()
						Turbine.Shell.WriteLine("Names:");
						for loggedEffects=0, table.maxn(s), 1 do
							Turbine.Shell.WriteLine(s[loggedEffects]);
						end
					end
	Wind:SetZOrder(2);

Wind.desc = Turbine.UI.Lotro.Button();
	Wind.desc:SetParent(Wind);
	Wind.desc:SetPosition(25,105);
	Wind.desc:SetSize(100,50);
	Wind.desc:SetText("List Description");
	Wind.desc.Click = function ()
						Turbine.Shell.WriteLine("Descriptions:");
						for loggedEffects=0, table.maxn(s), 1 do
							Turbine.Shell.WriteLine(s[loggedEffects]);
							Turbine.Shell.WriteLine(d[loggedEffects]);
							Turbine.Shell.WriteLine("");
						end
					end
	Wind:SetZOrder(2);

Wind.del = Turbine.UI.Lotro.Button();
	Wind.del:SetParent(Wind);
	Wind.del:SetPosition(150,105);
	Wind.del:SetSize(100,50);
	Wind.del:SetText("Delete List");
	Wind.del.Click = function ()
						Turbine.Shell.WriteLine("Deleted List!");
						delete();
					end
	Wind:SetZOrder(2);

Wind.save = Turbine.UI.Lotro.Button();
	Wind.save:SetParent(Wind);
	Wind.save:SetPosition(150,75);
	Wind.save:SetSize(100,50);
	Wind.save:SetText("Pointless Button");
	Wind.save.Click = function ()
						Turbine.Shell.WriteLine("Yeah, ok, we had fun, now stop hitting the button. I promise you nothing will happen. It's pointless, as I said...");
					end
	Wind:SetZOrder(2);

Wind.buff = Turbine.UI.Lotro.CheckBox();
	Wind.buff:SetParent(Wind);
	Wind.buff:SetPosition(25,25);
	Wind.buff:SetSize(100,50);
	Wind.buff:SetText("Buffs");
	Wind.buff:SetSelectable(true);
	--if () then
	Wind.buff:SetChecked(true);
	--else 
	--Wind.buff:SetChecked(false);
	--end
	Wind:SetZOrder(2);	

Wind.debuff = Turbine.UI.Lotro.CheckBox();
	Wind.debuff:SetParent(Wind);
	Wind.debuff:SetPosition(150,25);
	Wind.debuff:SetSize(100,50);
	Wind.debuff:SetText("Debuffs");
	Wind.debuff:SetSelectable(true);
	--if () then
	Wind.debuff:SetChecked(true);
	--else 
	--Wind.debuff:SetChecked(false);
	--end
	Wind:SetZOrder(2);
	
Wind.curable = Turbine.UI.Lotro.CheckBox();
	Wind.curable:SetParent(Wind);
	Wind.curable:SetPosition(275,25);
	Wind.curable:SetSize(100,50);
	Wind.curable:SetText("Curables");
	Wind.curable:SetSelectable(true);
	--if () then
	Wind.curable:SetChecked(true);
	--else 
	--Wind.curable:SetChecked(false);
	--end
	Wind:SetZOrder(2);
	
Wind.effl = Turbine.UI.Lotro.TextBox();
	Wind.effl:SetParent(Wind);
	Wind.effl:SetPosition(275,75);
	Wind.effl:SetSize(100,25);
	Wind.effl:SetText("Effectlog");
	
Wind.kunt = Turbine.UI.Lotro.TextBox();
	Wind.kunt:SetParent(Wind);
	Wind.kunt:SetPosition(275,105);
	Wind.kunt:SetSize(100,25);
	Wind.kunt:SetText("by Kunter");

--Callbacks
	AddCallback(EffectList,"EffectAdded",Logger);
	

--chat commands
Logg = class(Turbine.ShellCommand);

function Logg:Execute()
	Wind:SetVisible(true);
end

function Turbine.Plugin:Unload()
    RemoveCallback(EffectList,"EffectAdded",Logger);
	delete();
end
logg = Logg();
Turbine.Shell.AddCommand('el', logg);
